<template>
    <div class="container">
        <div class="row">
            <div class="col-6 m-auto pt-4">
                <h2 class="text-center">User registration</h2>
                <form v-on:submit.prevent="handleRegistrationSubmit">
                    <div v-if="errors">
                        <div class="alert alert-danger" v-for="error in errors">
                            {{ error.message }}
                        </div>
                    </div>
                    <div class="col text-center">
                        I already have account - <a href="/vue/login">Login</a>
                    </div>
                    <div v-if="success" class="alert alert-success">
                        {{ success }}
                    </div>
                    <div class="form-group">
                        <label for="exampleInputEmail1">Email address</label>
                        <input type="email" v-model="email" class="form-control" id="exampleInputEmail1"
                            aria-describedby="emailHelp" placeholder="Enter email" required>
                    </div>
                    <div class="form-group">
                        <label for="exampleInputPassword1">Password</label>
                        <input type="password" v-model="password" class="form-control" id="exampleInputPassword1"
                            placeholder="Password" required>
                    </div>
                    <div class="form-group">
                        <label for="exampleInputPassword1">Username</label>
                        <input type="text" v-model="username" class="form-control" id="exampleInputPassword1" required>
                    </div>
                    <div class="form-check pt-2">
                        <input type="checkbox" v-model="admin" class="form-check-input" id="exampleCheck1">
                        <label class="form-check-label" for="exampleCheck1">Admin</label>
                    </div>
                    <div class="text-center">
                        <button type="submit" class="btn btn-primary pt-2 w-50">Registrate</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
import axios from 'axios';

export default {
    data() {
        return {
            email: null,
            password: null,
            username: null,
            admin: 1,
            errors: [],
            success: '',
        }
    },
    props: ['user'],
    methods: {
        handleRegistrationSubmit() {
            this.isLoading = true;
            this.errors = [];
            this.success = '';
            let user_roles = [];

            if (this.admin === 1) {
                user_roles = ['ROLE_ADMIN'];
            }

            axios
                .post('/api/users', {
                    email: this.email,
                    password: this.password,
                    username: this.username,
                    roles: user_roles
                }, {
                    headers: {
                        'Contact-Type': 'application/json'
                    }
                })
                .then(response => {
                    if (response.headers.location) {
                        this.success = "You are succesfully registrated. Try log in !";
                    } else {
                        this.errors = [{ 'message': 'Unkown errror. Please try it later' }];    
                    }
                }).catch(error => {
                    this.errors = [{ 'message': 'Unkown errror. Please try it later' }];

                    if (error.response) {
                        if (error.response.data && error.response.data.violations) {
                            this.errors = error.response.data.violations;
                        }
                    }
                })
        },
    },
}
</script>
